﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=10.6
@EndOfDesignText@
'Code module
'Subs in this code module will be accessible from all modules.
Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	Public cadena As String
	Dim sf As StringFunctions
	Private xui As XUI
End Sub

Sub ordena_lineas_fechas
	'Ordenar un texto cuyas líneas empiezan con una fecha. Como el formato de fecha dd/mm/aaaa no es válido para
	'ordenar, debemos cambiar primero el comienzo de la línea por aaaa/mm/dd
	
	''En "cadena" tenemos el texto a ordenar. Como es una variable Global_Process se accede desde cualquier sitio
	'Debemos tener incorporada la librería StringFunctions
	
	Dim texto1,texto2,texto3 As String 'Para cambiar posición de fecha dd/mm/aaaa por aaaa/mm/dd
	Dim cambiar_fecha As String   'Para recoger la fecha una vez cambiada de posición
	Dim comodin As Int, cadena1 As String,cadena2 As String, cadena_modificada, nueva_linea As String
	Dim longitud_linea As Int
	
	comodin=0  'Comprobar que la fecha captura es de verdad fecha y no otros 10 caracteres cualquiera
	cadena1=""  'Par ir leyendo las líneas individuales
	cadena2=""  'Para ir leyendo carácter a carácter
	cadena_modificada=""   'Para ir creando la cadena con los incios de línea cambiados en la fecha
	nueva_linea=""  'Para ir incorporando las líneas modificadas
	longitud_linea=0  'Para ir recuperando las nuevas líneas modificadas

	If cadena.Length <10 Then    'Como minimo una cadena que contenga los 10 datos de la fecha dd/mm/aaaa
		xui.MsgboxAsync("NADA QUE ORDENAR","")
	Else
		For z=1 To cadena.Length
			cadena2=sf.Mid(cadena,z,1)
			If cadena2<>CRLF Then
				cadena1=cadena1 & cadena2	 'No hemos llegado al final de la línea
			End If
			
			If cadena2=CRLF And cadena1.Length>10 Then  'Hemos llegado al final de la línea
				texto1=sf.Mid(cadena1,1,2)  'Aquí tendremos el día
				texto2=sf.Mid(cadena1,4,2)  'Aquí tendremos el mes
				texto3=sf.Mid(cadena1,7,4)  'Aquí tendremos el año
				
				'Comprobamos que estas tres cadenas de verdad son fechas
				comodin=0
				If sf.Val(texto1)>31 Or sf.Val(texto1)<1 Then comodin=1
				If sf.Val(texto2)>12 Or sf.Val(texto2)<1 Then comodin=1
				If sf.Val(texto3)>2040 Or sf.Val(texto3)<2020 Then comodin=1
				
				If comodin=0 Then
					cambiar_fecha=texto3&"/"&texto2&"/"&texto1
				Else
					cambiar_fecha="2040/12/31"  'Para que no presente nada
					comodin=0
				End If
				longitud_linea=cadena1.Length
				nueva_linea=cambiar_fecha & sf.mid(cadena1,11,longitud_linea-10)
				
				cadena_modificada=cadena_modificada & nueva_linea &CRLF
				cadena1=""
				nueva_linea=""
			End If
		
		Next
		
	End If
	
	'Salimos con la cadena modificada en "cadena_modificada". La pasamos a "cadena" y al módulo ordenar líneas
	
	cadena=cadena_modificada
	Ordena_Texto.Ordena_Lineas_Texto  'Llamamos a la rutinade ordenar texto
	
	'Nos devuelve la cadena ordenada en "cadena". Ahora volvemos a poner las fechas en el orden anterior, para más fácil lectura
	
	cadena_modificada=""
	For z=1 To cadena.Length
		cadena2=sf.Mid(cadena,z,1)
		If cadena2<>CRLF Then
			cadena1=cadena1 & cadena2	 'No hemos llegado al final de la línea
		End If
			
		If cadena2=CRLF And cadena1.Length>10 Then  'Hemos llegado al final de la línea
			texto1=sf.Mid(cadena1,1,4)  'Aquí tendremos el año
			texto2=sf.Mid(cadena1,6,2)  'Aquí tendremos el mes
			texto3=sf.Mid(cadena1,9,2)  'Aquí tendremos el día
				
			'Comprobamos que estas tres cadenas de verdad son fechas
			comodin=0
			If sf.Val(texto1)>2040 Or sf.Val(texto1)<2020 Then comodin=1
			If sf.Val(texto2)>12 Or sf.Val(texto2)<1 Then comodin=1
			If sf.Val(texto3)>31 Or sf.Val(texto3)<1 Then comodin=1
				
			If comodin=0 Then
				cambiar_fecha=texto3&"/"&texto2&"/"&texto1
			Else
				cambiar_fecha="31/12/2040"  'Para que no presente nada
				comodin=0
			End If
			
			longitud_linea=cadena1.Length
			nueva_linea=cambiar_fecha & sf.mid(cadena1,11,longitud_linea-10)
				
			cadena_modificada=cadena_modificada & nueva_linea &CRLF
			cadena1=""
			nueva_linea=""
				
		End If
		
	Next
	'Salimos y asignamos a cadena para volver al origen y poner en su cajatexto ya ordenado
	cadena=cadena_modificada
End Sub