﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=10.6
@EndOfDesignText@
'Code module
'Subs in this code module will be accessible from all modules.
Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	Dim cadena As String
	Dim sf As StringFunctions
	Private xui As XUI
End Sub

Sub Ordena_Lineas_Texto
	
	'En "cadena" tenemos el texto a ordenar. Como es una variable Global_Process se accede desde cualquier sitio
	'Debemos tener incorporada la librería StringFunctions
	
	
	Dim cadena1,cadena2 As String
	Dim validez, contador As Int
	
	'Controlar antes de llegar a este módulo que el texto tiene al menos dos líneas
	If cadena.Length<1 Then xui.MsgboxAsync("No hay nada que ordenar","")
	
	'Primero vemos cuantas líneas tine el texto para dimensionar una matriz a su medida
	
	contador=0
		
	For z=1 To cadena.Length
		cadena2=sf.Mid(cadena,z,1)
		If cadena2=CRLF Then contador=contador+1
	Next
	
	'En contador tenemos el número mínimo de líneas
	Dim lineas(contador) As String
	
	'Ahora vamos a colocar cada línea en una posición de la matriz "lineas"
		
	contador=-1	'usamos contador para un controlando las líneas (la matriz empieza por cero (0)
		
	For y=1 To cadena.Length
		cadena2=sf.Mid(cadena,y,1)
		If cadena2<>CRLF Then
			cadena1=cadena1 & cadena2	 'No hemos llegado al final de la línea
		End If
			
		If cadena2=CRLF Then  'Hemos llegado al final de la línea
			If cadena1="" Then cadena1="***"  'Si hay dos CRLF seguidos, en el segundo ya se ha vaciado "cadena1"
			contador=contador+1
			lineas(contador)=cadena1
			cadena1=""
		End If
		
	Next
	
	'Ahora vamos a ordenar
	validez=0  'Inicializamos dándole un valor
	cadena1="":cadena2=""
	
	Do While validez=0   'Mientras no cambie validez, seguimos en el bucle
		validez=1
		For v=0 To contador-1
			cadena1=lineas(v)
			cadena2=lineas(v+1)
			If cadena1.CompareTo(cadena2)>0 Then
				validez=0
				lineas(v)=cadena2
				lineas(v+1)=cadena1
			End If
		Next
		
	Loop
	
	'Ya hemos salido y ordenado. Ahora pasamos a "cadena" la maatriz ordenada
	cadena=""
	For z=0 To contador
		cadena=cadena & lineas(z) & CRLF
	Next

End Sub